using System.Collections.Generic;
using System.Linq;
using System.Reflection;

using Windows.UI;

using Microsoft.UI;
using Microsoft.UI.Xaml.Controls;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        List<NamedColor> namedColorList = new List<NamedColor>();

        IEnumerable<PropertyInfo> propertyInfoEnumerable = typeof(Colors).GetRuntimeProperties();

        for(int i = 0; i < propertyInfoEnumerable.Count(); i++)
        {
            PropertyInfo propertyInfo = propertyInfoEnumerable.ElementAt(i);

            if(!propertyInfo.GetMethod.IsStatic)
            {
                continue;
            }

            if(propertyInfo.PropertyType != typeof(Color))
            {
                continue;
            }

            string name  = propertyInfo.Name;
            Color  color = (Color)propertyInfo.GetValue(null);

            NamedColor namedColor = new NamedColor(name, color);

            namedColorList.Add(namedColor);
        }

        this.listView.ItemsSource = namedColorList;
    }

    #endregion
}